{% extends "layouts/base.html" %}

{% block title %}
	{{ title }}
{% endblock %}

{% block content %}
	<div class="container py-2">
		<a class="btn btn btn-outline-secondary mb-2" href="/">←</a>
		<h3>{{ title }}</h3>
		<form id="registered_form">
			<!-- I want a table with two rows for each user, the first one has the username an a toggle that will open the second row -->
			<table class="table table-bordered table-striped table-sm">
				<thead class="thead-light">
					<tr>
						<th scope="col">Username</th>
						<th scope="col">Actions</th>
					</tr>
				</thead>
				<tbody>
					{% for user in approved_users %}
						<tr id="{{index}}-row-1">
							<td>{{user.username}}</td>
							<td>
								<button class="btn btn-primary" click="collapse('{{index}}-row-1')">Open User</button>
							</td>
						</tr>
						<!-- The second row will be hidden by default -->
						<!-- And be visible when the button ist clicked -->
						<tr id="{{index}}-row-2" class="collapse">
							<div class="">
								<div class="user-attributes">
									<table class="table table-bordered table-striped table-sm">
										<thead class="thead-light">
											<tr>
												<th scope="col">Attribute</th>
												<th scope="col">Value</th>
											</tr>
										</thead>
										<tbody>
											<tr>
												<td>{{ user.attributes | show_all_attrs}}</td>
											</tr>
										</tbody>
									</table>
								</div>
								<div class="user-roles">
									<table class="table table-bordered table-striped table-sm">
										<thead class="thead-light">
											<tr>
												<th scope="col">Role</th>
												<th scope="col">Actions</th>
											</tr>
										</thead>
										<tbody>
											{% for role in portal_roles %}
												<tr>
													<td>{{role}}</td>
													<td>
														{% if role in user.roles %}
															<button class="btn btn-primary">Enable Role</button>
														{% else %}
															<button class="btn btn-danger">Remove Role</button>
														{% endif %}
													</td>
												</tr>
											{% endfor %}
										</tbody>
									</table>
								</div>
							</div>
						</tr>
					{% endfor %}
				</tbody>
			</table>
			<br>
		</form>
	</div>
{% endblock %}

<style>
	.user-attributes {
		margin-top: 20px;
	}
	.user-roles {
		margin-top: 20px;
	}
	.show {
		display: table-row;
	}
	.collapse {
		display: none;
	}
</style>

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}
<script>

	// This function will toggle the rows
	function collapse(row_id) {
		// Get the row
		var row = document.getElementById(row_id);
		// If the row is open, close it
		if (row.classList.contains("show")) {
			row.classList.remove("show");
		}
		// If the row is closed, open it
		else {
			row.classList.add("show");
		}
	}

	
	$(".enableUser").click( function(event) {
		event.preventDefault();
		const currentRow = $(this).closest("tr"); 
		
		const email=currentRow.find("td:eq(0)").text(); // get current row 1st TD value
		const username=currentRow.find("td:eq(1)").text()
		const keycloak_id=currentRow.find("td:eq(2)").text()

		$.ajax({
			type: "POST",
			url: "{{ url_for('users_registration_review_blueprint.api_enable_user') }}",
			data: JSON.stringify({
				"email": email,
				"username": username,
				"keycloak_id": keycloak_id
			}),
			processData: false,
			contentType: 'application/json',
			success: function(response) {
				if (response.message == "success") {
					location.reload()
				}
			},
			error: function() {
				alert("SOMETHING WRONG!")
			}
		})
	});

	$(".removeUser").click( function(event) {
		event.preventDefault();
		const currentRow = $(this).closest("tr"); 
		
		const email=currentRow.find("td:eq(0)").text(); // get current row 1st TD value
		const username=currentRow.find("td:eq(1)").text()
		const keycloak_id=currentRow.find("td:eq(2)").text()

		$.ajax({
			type: "POST",
			url: "{{ url_for('users_registration_review_blueprint.api_disable_user') }}",
			data: JSON.stringify({
				"email": email,
				"username": username,
				"keycloak_id": keycloak_id
			}),
			processData: false,
			contentType: 'application/json',
			success: function(response) {
				if (response.message == "success") {
					location.reload()
				}
			},
			error: function() {
				alert("SOMETHING WRONG!")
			}
		})
	});

</script>
{% endblock javascripts %}
